package com.ejie.ab79.dao.AB63;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.AB63.Modalidades;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableRequestDto;

/**
 * ModalidadesDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class ModalidadesDaoImpl implements ModalidadesDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDMODALIDAD", "IDTIPOESTABLECIMIENTO",
			"DESCRIPCIONCASTELLANO", "BAJA", "DESCRIPCIONEUSKERA"};

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<Modalidades> rwMap = new RowMapper<Modalidades>() {
		public Modalidades mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new Modalidades(resultSet.getString("IDMODALIDAD"), resultSet.getString("IDTIPOESTABLECIMIENTO"),
					resultSet.getString("DESCRIPCIONCASTELLANO"), resultSet.getInt("BAJA"), resultSet.getString("DESCRIPCIONEUSKERA"));
		}
	};

	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	@Transactional(readOnly = true)
	public List<Modalidades> findAll(Modalidades modalidades, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_MODALIDAD IDMODALIDAD,t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, "
				+ " t1.BAJA BAJA,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA ");
		query.append("FROM MODALIDADES t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(modalidades);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, ModalidadesDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}


	private Map<String, ?> getWhereMap(Modalidades modalidades) {

		StringBuilder where = new StringBuilder(ModalidadesDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (modalidades != null && modalidades.getIdModalidad() != null) {
			where.append(" AND t1.ID_MODALIDAD = ?");
			params.add(modalidades.getIdModalidad());
		}
		if (modalidades != null && modalidades.getIdTipoEstablecimiento() != null) {
			where.append(" AND t1.ID_TIPO_ESTABLECIMIENTO = ?");
			params.add(modalidades.getIdTipoEstablecimiento());
		}
		if (modalidades != null && modalidades.getDescripcionCastellano() != null) {
			where.append(" AND t1.DESCRIPCION_CASTELLANO = ?");
			params.add(modalidades.getDescripcionCastellano());
		}
		if (modalidades != null && modalidades.getBaja() != null) {
			where.append(" AND t1.BAJA = ?");
			params.add(modalidades.getBaja());
		}
		if (modalidades != null && modalidades.getDescripcionEuskera() != null) {
			where.append(" AND t1.DESCRIPCION_EUSKERA = ?");
			params.add(modalidades.getDescripcionEuskera());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	public static final int STRING_BUILDER_INIT = 4096;
}
